/* 
 * EDOMI beta (Version 1.60) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
function app104_refresh(winId) {
	app104_info.ts=-1;
	var view=app104_views[((app104_info.mode==1)?"arc":"dvr")+app104_info.id];
	ajax("start","104",winId,"",app104_info.id+AJAX_SEPARATOR1+app104_info.mode+AJAX_SEPARATOR1+view);
}

function app104_setMode(winId,mode) {
	document.getElementById(winId+"-mode"+app104_info.mode).className="app104_modeB";
	document.getElementById(winId+"-mode"+mode).className="app104_modeA";
	app104_info.mode=mode;
	app104_info.id=app104_info.lastId[mode];
	var view=app104_views[((mode==1)?"arc":"dvr")+app104_info.id];
	ajax("start","104",winId,"",app104_info.id+AJAX_SEPARATOR1+app104_info.mode+AJAX_SEPARATOR1+view);
}

function app104_changeView(winId) {
	var view=document.getElementById(winId+"-view").dataset.value;
	app104_views[((app104_info.mode==1)?"arc":"dvr")+app104_info.id]=view;
	ajax("start","104",winId,"",app104_info.id+AJAX_SEPARATOR1+app104_info.mode+AJAX_SEPARATOR1+view);
}

function app104_metaLoadArray(winId,value) {
	ajax("metaLoadArray","104",winId,"",app104_info.id+AJAX_SEPARATOR1+app104_info.mode+AJAX_SEPARATOR1+app104_files[value][0]);
}

function app104_filesLoadImage(winId,value) {
	document.getElementById(winId+"-timeline").style.opacity="0.5";
	document.getElementById(winId+"-slider2").value=0;
	app104_loadImage(winId,{ts:app104_files[value][0],fn:app104_files[value][1],pos:app104_files[value][2],len:app104_files[value][3],caption:app104_files[value][4]});
}

function app104_metaLoadImage(winId,value) {
	document.getElementById(winId+"-timeline").style.opacity="1";
	app104_loadImage(winId,{ts:app104_meta[value][0],fn:app104_meta[value][1],pos:app104_meta[value][2],len:app104_meta[value][3],caption:app104_meta[value][4]});
}

function app104_loadImage(winId,meta) {
	if (app104_info.load) {
		var img=document.getElementById(winId+"-img");
		app104_info.ts=meta.ts;

		if (camView) {
			if (app104_info.mode==1) {
				camView.setProperty("url","../data/liveproject/cam/archiv/"+encodeURIComponent(meta.fn)+".jpg?nocache="+performance.now());		
			} else {
				camView.setProperty("url","apps/app_dvrloadimg.php?cmd=loadImg&appid=104&n1="+encodeURIComponent(meta.fn)+"&n2="+encodeURIComponent(meta.pos)+"&n3="+encodeURIComponent(meta.len)+"&nocache="+performance.now());		
			}
			if (app104_info.camviewInited) {
				camView.loadImage();
			} else {
				app104_info.camviewInited=true;
				camView.init();
			}
		} else {
			if (app104_info.mode==1) {
				img.src="../data/liveproject/cam/archiv/"+encodeURIComponent(meta.fn)+".jpg?nocache="+performance.now();
			} else {
				img.src="apps/app_dvrloadimg.php?cmd=loadImg&appid=104&n1="+encodeURIComponent(meta.fn)+"&n2="+encodeURIComponent(meta.pos)+"&n3="+encodeURIComponent(meta.len)+"&nocache="+performance.now();
			}
		}

		var tmp=meta.caption.split("/");
		if (app104_info.mode==1) {
			document.getElementById(winId+"-cap").innerHTML=tmp[0]+" / "+tmp[1]+" / "+tmp[2]+"<span style='color:#c0c0c0;'>."+tmp[3]+"</span>";
		} else {
			document.getElementById(winId+"-cap").innerHTML=tmp[0]+" / "+tmp[1]+" / "+tmp[2];
		}

		app104_info.load=false;
		app104_info.buffer=false;
	} else {
		app104_info.buffer=meta;
	}
}

function app104_imgOnLoad(winId) {
	app104_info.load=true;
	if (document.getElementById(winId+"-main")) {
		if (camView) {
			document.getElementById(winId+"-img").style.display="none";
			document.getElementById(winId+"-cnv").style.display="block";
		} else {
			document.getElementById(winId+"-img").style.display="block";
			document.getElementById(winId+"-cnv").style.display="none";
		}
	
		if (app104_info.buffer!==false) {
			app104_loadImage(winId,app104_info.buffer);
		}
	}
}

function app104_saveImage(winId) {
	if (document.getElementById(winId+"-buffsave").dataset.active=="0") {return;}
	var id=document.getElementById(winId+"-slider2").value;
	if (app104_meta[id]) {
		if (camView) {
			openBusyWindow();
			camView.setProperty("callback","app104_saveImageRendered(\""+winId+"\","+id+",true)");
			camView.setProperty("callbackerror","app104_saveImageRendered(\""+winId+"\","+id+",false)");
			camView.setProperty("db_srcs",100);
			camView.loadImage();
		} else {
			ajax("saveImage","104",winId,"",app104_meta[id][0]+AJAX_SEPARATOR1+app104_meta[id][1]+AJAX_SEPARATOR1+app104_meta[id][2]+AJAX_SEPARATOR1+app104_meta[id][3]+AJAX_SEPARATOR1+app104_meta[id][4]+AJAX_SEPARATOR1+app104_meta[id][5]+AJAX_SEPARATOR1+app104_meta[id][6]+AJAX_SEPARATOR1+app104_info.mode+AJAX_SEPARATOR1+app104_info.camViewId);
		}
	}
}

function app104_saveImageRendered(winId,id,ok) {
	camView.setProperty("callback","app104_imgOnLoad(\""+winId+"\")");
	camView.setProperty("callbackerror","app104_imgOnLoad(\""+winId+"\")");
	camView.setProperty("db_srcs",parseInt(document.getElementById(winId+"-srcs").value));
	hideBusyWindow();
	if (ok) {
		var tmp=document.getElementById(winId+"-cnv").toDataURL("image/jpeg",1);
		var data=tmp.split(",",2);
		if (data[1]) {
			ajax("saveImage","104",winId,data[1],app104_meta[id][0]+AJAX_SEPARATOR1+app104_meta[id][1]+AJAX_SEPARATOR1+app104_meta[id][2]+AJAX_SEPARATOR1+app104_meta[id][3]+AJAX_SEPARATOR1+app104_meta[id][4]+AJAX_SEPARATOR1+app104_meta[id][5]+AJAX_SEPARATOR1+app104_meta[id][6]+AJAX_SEPARATOR1+app104_info.mode+AJAX_SEPARATOR1+app104_info.camViewId);
		} else {
			ok=false;
		}
	}
	if (!ok) {
		jsConfirm("Beim Ablegen der Bildkopie ist ein Problem aufgetreten.","","none");
	}
}

function app104_addItem(winId,id,name,mode,selected,disabled) {
	menuItem=createNewDiv(winId+"-list",winId+"-i-"+id);
	menuItem.className="controlListItem";
	menuItem.style.display="block";
	if (disabled) {menuItem.style.opacity="0.5";}
	menuItem.style.color="#ffffff";
	menuItem.innerHTML=name+" <span class='id'>"+id+"</span>";

	if (selected) {
		menuItem.style.background=apps_colorSelected;
	} else {
		menuItem.style.background="#343434";
	}

	var view=app104_views[((mode==1)?"arc":"dvr")+id];
	menuItem.setAttribute("onMouseDown","ajax(\"start\",\"104\",\""+winId+"\",\"\",\""+id+AJAX_SEPARATOR1+mode+AJAX_SEPARATOR1+view+"\");");
}

function app104_addFolder(winId,id,name) {
	menuItem=createNewDiv(winId+"-list",winId+"-f-"+id);
	menuItem.className="controlListItem";
	menuItem.style.display="block";
	menuItem.style.color="#7070ff";
	menuItem.style.background="#343434";
	menuItem.innerHTML="<div style='padding-top:3px;'>"+name+"</div><div style='width:100%; height:1px; margin:3px 0 0 0; background:#7070ff;'></div>";
}

function app104_setSrcs(winId,value) {
	if (camView) {
		camView.setProperty("db_srcs",value);
		document.getElementById(winId+"-srcscaption").innerHTML=value+"%";
		var tmp=document.getElementById(winId+"-slider2").value;
		app104_metaLoadImage(winId,tmp);
	}
}

function app104_addStep1(winId,step) {
	var sl=document.getElementById(winId+"-slider1");
	var value=parseInt(sl.value)+step;
	if (value>=0 && value<app104_files.length) {
		sl.value=value;
		app104_metaLoadArray(winId,value);
	}
}

function app104_addStep2(winId,step) {
	var sl=document.getElementById(winId+"-slider2");
	var value=parseInt(sl.value)+step;
	if (value<0) {
		app104_addStep1(winId,-1);
	} else if (value>=app104_meta.length) {
		app104_addStep1(winId,1);
	} else {
		sl.value=value;
		app104_loadImage(winId,{ts:app104_meta[value][0],fn:app104_meta[value][1],pos:app104_meta[value][2],len:app104_meta[value][3],caption:app104_meta[value][4]});
	}
}

function app104_play2(winId,step,mode) {
	if (mode==1) {
		window.clearInterval(app104_info.timer);
		app104_info.timer=window.setInterval(function(){app104_info.play=true;app104_addStep2(winId,step);},250);
	} else if (mode==0) {
		window.clearInterval(app104_info.timer);
		if (!app104_info.play) {app104_addStep2(winId,step);}
	} else if (mode==-1) {
		window.clearInterval(app104_info.timer);
	}
	app104_info.play=false;
}

function app104_getHour(ts) {
	var tmp=new Date(ts*1000);
	var d=tmp.getFullYear()+digits(tmp.getMonth()+1)+digits(tmp.getDate())+digits(tmp.getHours());
	return parseInt(d);
	
	function digits(n) {
		if (n<10) {n="0"+n;}
		return n;
	}
}

function app104_getDay(ts) {
	var tmp=new Date(ts*1000);
	var d=tmp.getFullYear()+digits(tmp.getMonth()+1)+digits(tmp.getDate());
	return parseInt(d);
	
	function digits(n) {
		if (n<10) {n="0"+n;}
		return n;
	}
}
